module     P4B_ddx_ddx_d14h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity0/d14h0l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram14_sign, shift => diagram14_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd14h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d14
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d14 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t12 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t13 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t14 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d14 = (t1*abb14n13+t2*abb14n14+t3*abb14n14+t4*abb14n15+t5*abb14n25+t6*abb1&
      &4n26+t6*t6*abb14n43+t7*abb14n27+t8*abb14n41+t9*abb14n47+t1*t5*abb14n22+t1&
      &*t6*abb14n23+t1*t7*abb14n24+t1*t8*abb14n12+t1*t9*abb14n48+t10*t11*abb14n1&
      &1+t10*t12*abb14n19+t10*t2*abb14n20+t10*t5*abb14n37+t10*t6*abb14n38+t10*t7&
      &*abb14n39+t10*t8*abb14n45+t10*t9*abb14n60+t11*t6*abb14n2+t12*t6*abb14n6+t&
      &13*t6*abb14n21+t2*t6*abb14n7+t2*t9*abb14n50+t3*t9*abb14n50+t4*t5*abb14n28&
      &+t4*t6*abb14n29+t4*t7*abb14n30+t4*t8*abb14n16+t4*t9*abb14n52+t5*t6*abb14n&
      &42+t5*t9*abb14n50+t6*t7*abb14n44+t6*t8*abb14n17+t6*t9*abb14n57+t7*t9*abb1&
      &4n49+t8*t9*abb14n51+t1*t10*t5*abb14n34+t1*t10*t6*abb14n35+t1*t10*t7*abb14&
      &n36+t1*t10*t9*abb14n59+t1*t13*t8*abb14n18+t1*t13*t9*abb14n61+t1*t14*t5*ab&
      &b14n10+t1*t14*t6*abb14n9+t1*t14*t7*abb14n8+t1*t15*t5*abb14n31+t1*t15*t6*a&
      &bb14n32+t1*t15*t7*abb14n33+t1*t5*t8*abb14n3+t1*t5*t9*abb14n55+t1*t6*t8*ab&
      &b14n4+t1*t7*t8*abb14n5+t1*t7*t9*abb14n54+t1*t9*abb14n40*(Q(1)*spvak2k1(1)&
      &-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t10*t11*t9*abb14n46+&
      &t10*t12*t9*abb14n62+t10*t2*t9*abb14n65+t10*t6*t9*abb14n66+t10*t8*t9*abb14&
      &n64+t4*t6*t9*abb14n56+t4*t8*t9*abb14n53+t6*t8*t9*abb14n58+t6*t9*abb14n63*&
      &(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t1*&
      &t10*t8*t9*abb14n67)
      numerator = cmplx(real(d14, ki), aimag(d14), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd14h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d14
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d14 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t12 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t13 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4)&
      &)
      t14 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d14 = (t1*abb14n13+t2*abb14n14+t3*abb14n14+t4*abb14n15+t5*abb14n25+t6*abb1&
      &4n26+t6*t6*abb14n43+t7*abb14n27+t8*abb14n41+t9*abb14n47+t1*t5*abb14n22+t1&
      &*t6*abb14n23+t1*t7*abb14n24+t1*t8*abb14n12+t1*t9*abb14n48+t10*t11*abb14n1&
      &1+t10*t12*abb14n19+t10*t2*abb14n20+t10*t5*abb14n37+t10*t6*abb14n38+t10*t7&
      &*abb14n39+t10*t8*abb14n45+t10*t9*abb14n60+t11*t6*abb14n2+t12*t6*abb14n6+t&
      &13*t6*abb14n21+t2*t6*abb14n7+t2*t9*abb14n50+t3*t9*abb14n50+t4*t5*abb14n28&
      &+t4*t6*abb14n29+t4*t7*abb14n30+t4*t8*abb14n16+t4*t9*abb14n52+t5*t6*abb14n&
      &42+t5*t9*abb14n50+t6*t7*abb14n44+t6*t8*abb14n17+t6*t9*abb14n57+t7*t9*abb1&
      &4n49+t8*t9*abb14n51+t1*t10*t5*abb14n34+t1*t10*t6*abb14n35+t1*t10*t7*abb14&
      &n36+t1*t10*t9*abb14n59+t1*t13*t8*abb14n18+t1*t13*t9*abb14n61+t1*t14*t5*ab&
      &b14n10+t1*t14*t6*abb14n9+t1*t14*t7*abb14n8+t1*t15*t5*abb14n31+t1*t15*t6*a&
      &bb14n32+t1*t15*t7*abb14n33+t1*t5*t8*abb14n3+t1*t5*t9*abb14n55+t1*t6*t8*ab&
      &b14n4+t1*t7*t8*abb14n5+t1*t7*t9*abb14n54+t1*t9*abb14n40*(Q(1)*spvak2k1(1)&
      &-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t10*t11*t9*abb14n46+&
      &t10*t12*t9*abb14n62+t10*t2*t9*abb14n65+t10*t6*t9*abb14n66+t10*t8*t9*abb14&
      &n64+t4*t6*t9*abb14n56+t4*t8*t9*abb14n53+t6*t8*t9*abb14n58+t6*t9*abb14n63*&
      &(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t1*&
      &t10*t8*t9*abb14n67)

      numerator = cmplx(real(d14, ki), aimag(d14), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d14h0l1
