module     P4B_ddx_ddx_d18h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity0/d18h0l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram18_sign, shift => diagram18_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd18h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d18
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d18 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t11 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t12 = t2*abb18n30
      t13 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t14 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t15 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t16 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d18 = (t1*abb18n14+t10*abb18n8+t11*abb18n9+t12*t6+t12*t7+t12*t8+t2*abb18n1&
      &5+t2*t2*abb18n29+t3*abb18n16+t4*abb18n20+t5*abb18n26+t6*abb18n6+t7*abb18n&
      &6+t8*abb18n6+t9*abb18n7+t1*t11*abb18n17+t1*t13*abb18n43+t1*t5*abb18n11+t1&
      &0*t11*abb18n10+t10*t13*abb18n38+t10*t2*abb18n3+t10*t4*abb18n32+t10*t5*abb&
      &18n5+t11*t2*abb18n18+t11*t3*abb18n19+t11*t4*abb18n24+t13*t14*abb18n37+t13&
      &*t2*abb18n44+t13*t3*abb18n45+t13*t4*abb18n53+t13*t5*abb18n36+t13*t6*abb18&
      &n34+t13*t7*abb18n34+t13*t8*abb18n34+t13*t9*abb18n35+t2*t4*abb18n22+t2*t5*&
      &abb18n12+t2*t9*abb18n28+t3*t5*abb18n13+t4*t5*abb18n27+t4*t6*abb18n21+t4*t&
      &7*abb18n21+t4*t8*abb18n21+t4*t9*abb18n23+t1*t10*t13*abb18n47+t1*t13*t15*a&
      &bb18n49+t1*t13*t16*abb18n57+t1*t13*t4*abb18n61+t1*t13*t5*abb18n40+t10*t11&
      &*t4*abb18n25+t10*t13*t14*abb18n39+t10*t13*t3*abb18n48+t10*t13*t4*abb18n52&
      &+t10*t14*t2*abb18n4+t10*t2*t4*abb18n33+t10*t2*t5*abb18n2+t10*t2*abb18n31*&
      &(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t13&
      &*t14*t4*abb18n54+t13*t15*t2*abb18n50+t13*t15*t3*abb18n51+t13*t16*t2*abb18&
      &n56+t13*t16*t3*abb18n55+t13*t2*t4*abb18n60+t13*t2*t5*abb18n41+t13*t3*t4*a&
      &bb18n59+t13*t3*t5*abb18n42+t13*t4*t5*abb18n64+t13*t4*t6*abb18n58+t13*t4*t&
      &7*abb18n58+t13*t4*t8*abb18n58+t13*t4*t9*abb18n62+t13*t4*abb18n46*(Q(1)*sp&
      &vak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t13*t4*abb1&
      &8n63*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)+t10*t13*t4*t5*abb18n65)
      numerator = cmplx(real(d18, ki), aimag(d18), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd18h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d18
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d18 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t11 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t12 = t2*abb18n30
      t13 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t14 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t15 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t16 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d18 = (t1*abb18n14+t10*abb18n8+t11*abb18n9+t12*t6+t12*t7+t12*t8+t2*abb18n1&
      &5+t2*t2*abb18n29+t3*abb18n16+t4*abb18n20+t5*abb18n26+t6*abb18n6+t7*abb18n&
      &6+t8*abb18n6+t9*abb18n7+t1*t11*abb18n17+t1*t13*abb18n43+t1*t5*abb18n11+t1&
      &0*t11*abb18n10+t10*t13*abb18n38+t10*t2*abb18n3+t10*t4*abb18n32+t10*t5*abb&
      &18n5+t11*t2*abb18n18+t11*t3*abb18n19+t11*t4*abb18n24+t13*t14*abb18n37+t13&
      &*t2*abb18n44+t13*t3*abb18n45+t13*t4*abb18n53+t13*t5*abb18n36+t13*t6*abb18&
      &n34+t13*t7*abb18n34+t13*t8*abb18n34+t13*t9*abb18n35+t2*t4*abb18n22+t2*t5*&
      &abb18n12+t2*t9*abb18n28+t3*t5*abb18n13+t4*t5*abb18n27+t4*t6*abb18n21+t4*t&
      &7*abb18n21+t4*t8*abb18n21+t4*t9*abb18n23+t1*t10*t13*abb18n47+t1*t13*t15*a&
      &bb18n49+t1*t13*t16*abb18n57+t1*t13*t4*abb18n61+t1*t13*t5*abb18n40+t10*t11&
      &*t4*abb18n25+t10*t13*t14*abb18n39+t10*t13*t3*abb18n48+t10*t13*t4*abb18n52&
      &+t10*t14*t2*abb18n4+t10*t2*t4*abb18n33+t10*t2*t5*abb18n2+t10*t2*abb18n31*&
      &(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t13&
      &*t14*t4*abb18n54+t13*t15*t2*abb18n50+t13*t15*t3*abb18n51+t13*t16*t2*abb18&
      &n56+t13*t16*t3*abb18n55+t13*t2*t4*abb18n60+t13*t2*t5*abb18n41+t13*t3*t4*a&
      &bb18n59+t13*t3*t5*abb18n42+t13*t4*t5*abb18n64+t13*t4*t6*abb18n58+t13*t4*t&
      &7*abb18n58+t13*t4*t8*abb18n58+t13*t4*t9*abb18n62+t13*t4*abb18n46*(Q(1)*sp&
      &vak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t13*t4*abb1&
      &8n63*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)+t10*t13*t4*t5*abb18n65)

      numerator = cmplx(real(d18, ki), aimag(d18), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d18h0l1
