module     P4B_ddx_ddx_d24h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity0/d24h0l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram24_sign, shift => diagram24_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd24h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6-k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t3 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t4 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t7 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t11 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t12 = t7*abb24n28
      t13 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t14 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      d24 = (t1*t12+t1*abb24n10+t10*abb24n5+t11*abb24n9+t12*t2+t12*t3+t2*abb24n1&
      &0+t3*abb24n10+t4*abb24n11+t5*abb24n13+t6*abb24n15+t7*abb24n18+t7*t7*abb24&
      &n27+t8*abb24n3+t9*abb24n3+t1*t10*abb24n6+t10*t11*abb24n7+t10*t13*abb24n34&
      &+t10*t2*abb24n6+t10*t3*abb24n6+t10*t4*abb24n8+t10*t5*abb24n12+t10*t6*abb2&
      &4n30+t10*t7*abb24n24+t11*t7*abb24n26+t13*t7*abb24n36+t13*t8*abb24n35+t4*t&
      &6*abb24n16+t4*t7*abb24n19+t4*t8*abb24n4+t4*t9*abb24n4+t5*t6*abb24n14+t5*t&
      &7*abb24n20+t5*t8*abb24n2+t5*t9*abb24n2+t6*t7*abb24n22+t7*t8*abb24n25+t1*t&
      &10*t13*abb24n38+t10*t11*t13*abb24n40+t10*t13*t14*abb24n41+t10*t13*t2*abb2&
      &4n38+t10*t13*t3*abb24n38+t10*t13*t5*abb24n42+t10*t13*t6*abb24n43+t10*t13*&
      &t7*abb24n39+t10*t4*t6*abb24n17+t10*t6*t7*abb24n31+t13*t14*t7*abb24n37+t13&
      &*t5*t7*abb24n32+t13*t5*t8*abb24n33+t13*t7*abb24n44*(Q(1)*spvak2k8(1)-Q(2)&
      &*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t5*t6*t7*abb24n21+t6*t7*a&
      &bb24n23*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6&
      &(4))+t6*t7*abb24n29*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q&
      &(4)*spvak5k8(4))+t10*t13*t5*t6*abb24n45)
      numerator = cmplx(real(d24, ki), aimag(d24), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd24h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6-k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t3 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t4 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))
      t5 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t6 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t7 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t11 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t12 = t7*abb24n28
      t13 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t14 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      d24 = (t1*t12+t1*abb24n10+t10*abb24n5+t11*abb24n9+t12*t2+t12*t3+t2*abb24n1&
      &0+t3*abb24n10+t4*abb24n11+t5*abb24n13+t6*abb24n15+t7*abb24n18+t7*t7*abb24&
      &n27+t8*abb24n3+t9*abb24n3+t1*t10*abb24n6+t10*t11*abb24n7+t10*t13*abb24n34&
      &+t10*t2*abb24n6+t10*t3*abb24n6+t10*t4*abb24n8+t10*t5*abb24n12+t10*t6*abb2&
      &4n30+t10*t7*abb24n24+t11*t7*abb24n26+t13*t7*abb24n36+t13*t8*abb24n35+t4*t&
      &6*abb24n16+t4*t7*abb24n19+t4*t8*abb24n4+t4*t9*abb24n4+t5*t6*abb24n14+t5*t&
      &7*abb24n20+t5*t8*abb24n2+t5*t9*abb24n2+t6*t7*abb24n22+t7*t8*abb24n25+t1*t&
      &10*t13*abb24n38+t10*t11*t13*abb24n40+t10*t13*t14*abb24n41+t10*t13*t2*abb2&
      &4n38+t10*t13*t3*abb24n38+t10*t13*t5*abb24n42+t10*t13*t6*abb24n43+t10*t13*&
      &t7*abb24n39+t10*t4*t6*abb24n17+t10*t6*t7*abb24n31+t13*t14*t7*abb24n37+t13&
      &*t5*t7*abb24n32+t13*t5*t8*abb24n33+t13*t7*abb24n44*(Q(1)*spvak2k8(1)-Q(2)&
      &*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4))+t5*t6*t7*abb24n21+t6*t7*a&
      &bb24n23*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6&
      &(4))+t6*t7*abb24n29*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q&
      &(4)*spvak5k8(4))+t10*t13*t5*t6*abb24n45)

      numerator = cmplx(real(d24, ki), aimag(d24), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d24h0l1
