module     P4B_ddx_ddx_d56h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity0/d56h0l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram56_sign, shift => diagram56_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd56h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d56
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d56 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = t1*abb56n12
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = t1*abb56n13
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t16 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t17 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t18 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t19 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t20 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t21 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t22 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t23 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t24 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t25 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d56 = (t1*abb56n41+t1*abb56n6+t10*t9+t11*t12+t12*t13+t2*abb56n42+t3*abb56n&
      &47+t4*abb56n7+t8*t9+t1*t20*abb56n45+t1*t3*abb56n58+t1*t6*abb56n15+t1*t7*a&
      &bb56n18+t1*abb56n20*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q&
      &(4)*spvak5k4(4))+t1*abb56n21*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spva&
      &k6k4(3)-Q(4)*spvak6k4(4))+t1*abb56n22*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-&
      &Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t1*abb56n23*(Q(1)*spvak8k4(1)-Q(2)*spv&
      &ak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t1*abb56n36*(Q(1)*spvak2k5(1)&
      &-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*abb56n37*(Q(1)*sp&
      &vak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t1*abb56n38&
      &*(Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4))+t1&
      &*abb56n43*(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2&
      &k8(4))+t10*t21*abb56n48+t10*t5*abb56n8+t11*t21*abb56n49+t11*t5*abb56n9+t1&
      &3*t21*abb56n49+t13*t5*abb56n9+t14*t16*abb56n25+t14*t17*abb56n27+t14*t18*a&
      &bb56n28+t14*t19*abb56n30+t14*t20*abb56n40+t14*t22*abb56n53+t14*t23*abb56n&
      &55+t14*t24*abb56n56+t14*t25*abb56n59+t14*t3*abb56n61+t14*t6*abb56n14+t14*&
      &t7*abb56n19+t15*t16*abb56n24+t15*t17*abb56n26+t15*t18*abb56n29+t15*t19*ab&
      &b56n31+t15*t20*abb56n39+t15*t22*abb56n52+t15*t23*abb56n54+t15*t24*abb56n5&
      &7+t15*t25*abb56n60+t15*t3*abb56n62+t15*t6*abb56n16+t15*t7*abb56n17+t16*t2&
      &0*abb56n33+t17*t20*abb56n32+t18*t20*abb56n35+t19*t20*abb56n34+t2*t20*abb5&
      &6n46+t20*t22*abb56n63+t20*t23*abb56n64+t20*t24*abb56n65+t20*t25*abb56n66+&
      &t20*t3*abb56n67+t20*t4*abb56n44+t21*t6*abb56n50+t21*t7*abb56n51+t21*t8*ab&
      &b56n48+t5*t6*abb56n10+t5*t7*abb56n11+t5*t8*abb56n8+t10*t20*t3*abb56n69+t1&
      &1*t20*t3*abb56n68+t13*t20*t3*abb56n68+t20*t3*t6*abb56n70+t20*t3*t7*abb56n&
      &71+t20*t3*t8*abb56n69)
      numerator = cmplx(real(d56, ki), aimag(d56), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd56h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d56
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d56 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = t1*abb56n12
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = t1*abb56n13
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t16 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t17 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t18 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t19 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t20 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t21 = (Q(1)*spvak1k4(1)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4)&
      &)
      t22 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t23 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t24 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t25 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      d56 = (t1*abb56n41+t1*abb56n6+t10*t9+t11*t12+t12*t13+t2*abb56n42+t3*abb56n&
      &47+t4*abb56n7+t8*t9+t1*t20*abb56n45+t1*t3*abb56n58+t1*t6*abb56n15+t1*t7*a&
      &bb56n18+t1*abb56n20*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q&
      &(4)*spvak5k4(4))+t1*abb56n21*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spva&
      &k6k4(3)-Q(4)*spvak6k4(4))+t1*abb56n22*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-&
      &Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t1*abb56n23*(Q(1)*spvak8k4(1)-Q(2)*spv&
      &ak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t1*abb56n36*(Q(1)*spvak2k5(1)&
      &-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t1*abb56n37*(Q(1)*sp&
      &vak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t1*abb56n38&
      &*(Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4))+t1&
      &*abb56n43*(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2&
      &k8(4))+t10*t21*abb56n48+t10*t5*abb56n8+t11*t21*abb56n49+t11*t5*abb56n9+t1&
      &3*t21*abb56n49+t13*t5*abb56n9+t14*t16*abb56n25+t14*t17*abb56n27+t14*t18*a&
      &bb56n28+t14*t19*abb56n30+t14*t20*abb56n40+t14*t22*abb56n53+t14*t23*abb56n&
      &55+t14*t24*abb56n56+t14*t25*abb56n59+t14*t3*abb56n61+t14*t6*abb56n14+t14*&
      &t7*abb56n19+t15*t16*abb56n24+t15*t17*abb56n26+t15*t18*abb56n29+t15*t19*ab&
      &b56n31+t15*t20*abb56n39+t15*t22*abb56n52+t15*t23*abb56n54+t15*t24*abb56n5&
      &7+t15*t25*abb56n60+t15*t3*abb56n62+t15*t6*abb56n16+t15*t7*abb56n17+t16*t2&
      &0*abb56n33+t17*t20*abb56n32+t18*t20*abb56n35+t19*t20*abb56n34+t2*t20*abb5&
      &6n46+t20*t22*abb56n63+t20*t23*abb56n64+t20*t24*abb56n65+t20*t25*abb56n66+&
      &t20*t3*abb56n67+t20*t4*abb56n44+t21*t6*abb56n50+t21*t7*abb56n51+t21*t8*ab&
      &b56n48+t5*t6*abb56n10+t5*t7*abb56n11+t5*t8*abb56n8+t10*t20*t3*abb56n69+t1&
      &1*t20*t3*abb56n68+t13*t20*t3*abb56n68+t20*t3*t6*abb56n70+t20*t3*t7*abb56n&
      &71+t20*t3*t8*abb56n69)

      numerator = cmplx(real(d56, ki), aimag(d56), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d56h0l1
