module     P4B_ddx_ddx_d34h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity1/d34h1l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram34_sign, shift => diagram34_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd34h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d34
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d34 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t12 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t16 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t17 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t18 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t19 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t2*abb34n5
      t25 = t2*abb34n6
      d34 = (t1*abb34n14+t10*t24+t11*t25+t12*t25+t2*abb34n32+t24*t8+t3*abb34n33+&
      &t4*abb34n45+t1*t18*abb34n35+t10*t19*abb34n38+t10*t9*abb34n16+t11*t19*abb3&
      &4n37+t11*t9*abb34n17+t12*t19*abb34n37+t12*t9*abb34n17+t13*t19*abb34n39+t1&
      &3*t2*abb34n8+t13*t5*abb34n7+t13*t7*abb34n7+t13*t9*abb34n18+t14*t18*abb34n&
      &25+t14*t5*abb34n20+t14*t7*abb34n20+t15*t18*abb34n24+t15*t5*abb34n21+t15*t&
      &7*abb34n21+t16*t18*abb34n27+t16*t5*abb34n22+t16*t7*abb34n22+t17*t18*abb34&
      &n26+t17*t5*abb34n23+t17*t7*abb34n23+t18*t2*abb34n36+t18*t20*abb34n46+t18*&
      &t21*abb34n47+t18*t22*abb34n48+t18*t23*abb34n49+t18*t3*abb34n35+t18*t4*abb&
      &34n52+t18*t5*abb34n31+t18*t7*abb34n31+t19*t6*abb34n40+t19*t8*abb34n38+t2*&
      &t4*abb34n50+t2*t6*abb34n9+t2*abb34n11*(Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-&
      &Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))+t2*abb34n12*(Q(1)*spvak6k3(1)-Q(2)*spv&
      &ak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4))+t2*abb34n13*(Q(1)*spvak7k3(1)&
      &-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))+t2*abb34n15*(Q(1)*sp&
      &vak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4))+t2*abb34n28&
      &*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t2&
      &*abb34n29*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4&
      &k6(4))+t2*abb34n30*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(&
      &4)*spvak4k7(4))+t2*abb34n34*(Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak&
      &4k8(3)-Q(4)*spvak4k8(4))+t20*t5*abb34n41+t20*t7*abb34n41+t21*t5*abb34n42+&
      &t21*t7*abb34n42+t22*t5*abb34n43+t22*t7*abb34n43+t23*t5*abb34n44+t23*t7*ab&
      &b34n44+t4*t5*abb34n51+t4*t7*abb34n51+t5*t6*abb34n10+t6*t7*abb34n10+t6*t9*&
      &abb34n19+t8*t9*abb34n16+t10*t18*t4*abb34n54+t11*t18*t4*abb34n53+t12*t18*t&
      &4*abb34n53+t13*t18*t4*abb34n55+t18*t4*t6*abb34n56+t18*t4*t8*abb34n54)
      numerator = cmplx(real(d34, ki), aimag(d34), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd34h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d34
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d34 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t12 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t15 = (Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4)&
      &)
      t16 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t17 = (Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8k2(4)&
      &)
      t18 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t19 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t20 = (Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4)&
      &)
      t21 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4)&
      &)
      t22 = (Q(1)*spvak1k7(1)-Q(2)*spvak1k7(2)-Q(3)*spvak1k7(3)-Q(4)*spvak1k7(4)&
      &)
      t23 = (Q(1)*spvak1k8(1)-Q(2)*spvak1k8(2)-Q(3)*spvak1k8(3)-Q(4)*spvak1k8(4)&
      &)
      t24 = t2*abb34n5
      t25 = t2*abb34n6
      d34 = (t1*abb34n14+t10*t24+t11*t25+t12*t25+t2*abb34n32+t24*t8+t3*abb34n33+&
      &t4*abb34n45+t1*t18*abb34n35+t10*t19*abb34n38+t10*t9*abb34n16+t11*t19*abb3&
      &4n37+t11*t9*abb34n17+t12*t19*abb34n37+t12*t9*abb34n17+t13*t19*abb34n39+t1&
      &3*t2*abb34n8+t13*t5*abb34n7+t13*t7*abb34n7+t13*t9*abb34n18+t14*t18*abb34n&
      &25+t14*t5*abb34n20+t14*t7*abb34n20+t15*t18*abb34n24+t15*t5*abb34n21+t15*t&
      &7*abb34n21+t16*t18*abb34n27+t16*t5*abb34n22+t16*t7*abb34n22+t17*t18*abb34&
      &n26+t17*t5*abb34n23+t17*t7*abb34n23+t18*t2*abb34n36+t18*t20*abb34n46+t18*&
      &t21*abb34n47+t18*t22*abb34n48+t18*t23*abb34n49+t18*t3*abb34n35+t18*t4*abb&
      &34n52+t18*t5*abb34n31+t18*t7*abb34n31+t19*t6*abb34n40+t19*t8*abb34n38+t2*&
      &t4*abb34n50+t2*t6*abb34n9+t2*abb34n11*(Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-&
      &Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))+t2*abb34n12*(Q(1)*spvak6k3(1)-Q(2)*spv&
      &ak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4))+t2*abb34n13*(Q(1)*spvak7k3(1)&
      &-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4))+t2*abb34n15*(Q(1)*sp&
      &vak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4))+t2*abb34n28&
      &*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t2&
      &*abb34n29*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4&
      &k6(4))+t2*abb34n30*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(&
      &4)*spvak4k7(4))+t2*abb34n34*(Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak&
      &4k8(3)-Q(4)*spvak4k8(4))+t20*t5*abb34n41+t20*t7*abb34n41+t21*t5*abb34n42+&
      &t21*t7*abb34n42+t22*t5*abb34n43+t22*t7*abb34n43+t23*t5*abb34n44+t23*t7*ab&
      &b34n44+t4*t5*abb34n51+t4*t7*abb34n51+t5*t6*abb34n10+t6*t7*abb34n10+t6*t9*&
      &abb34n19+t8*t9*abb34n16+t10*t18*t4*abb34n54+t11*t18*t4*abb34n53+t12*t18*t&
      &4*abb34n53+t13*t18*t4*abb34n55+t18*t4*t6*abb34n56+t18*t4*t8*abb34n54)

      numerator = cmplx(real(d34, ki), aimag(d34), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d34h1l1
