module     P4B_ddx_ddx_d7h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity1/d7h1l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram7_sign, shift => diagram7_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd7h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d7
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d7 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t12 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t13 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t14 = t2*abb7n33
      t15 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t16 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      d7 = (t1*abb7n20+t14*t3+t14*t4+t2*abb7n23+t2*t2*abb7n34+t3*abb7n24+t4*abb7&
      &n24+t5*abb7n38+t6*abb7n5+t7*abb7n5+t8*abb7n6+t9*abb7n7+t1*t10*abb7n21+t1*&
      &t2*abb7n16+t1*t5*abb7n46+t1*t8*abb7n3+t1*t9*abb7n4+t10*t12*abb7n2+t10*t13&
      &*abb7n9+t10*t2*abb7n32+t10*t3*abb7n31+t10*t4*abb7n31+t10*t5*abb7n40+t10*t&
      &6*abb7n10+t11*t2*abb7n11+t12*t2*abb7n12+t13*t2*abb7n15+t2*t5*abb7n44+t2*t&
      &6*abb7n17+t2*t8*abb7n26+t2*t9*abb7n27+t3*t5*abb7n43+t3*t8*abb7n25+t3*t9*a&
      &bb7n28+t4*t5*abb7n43+t4*t8*abb7n25+t4*t9*abb7n28+t5*t6*abb7n45+t5*t7*abb7&
      &n45+t5*t8*abb7n48+t5*t9*abb7n49+t1*t10*t5*abb7n54+t1*t11*t8*abb7n8+t1*t2*&
      &t5*abb7n50+t1*t2*t8*abb7n13+t1*t3*t8*abb7n14+t1*t4*t8*abb7n14+t1*t5*t9*ab&
      &b7n47+t10*t12*t5*abb7n22+t10*t13*t5*abb7n39+t10*t2*t5*abb7n56+t10*t2*t8*a&
      &bb7n35+t10*t3*t8*abb7n36+t10*t4*t8*abb7n36+t10*t5*t6*abb7n55+t10*t5*t8*ab&
      &b7n41+t11*t5*t8*abb7n42+t15*t2*t8*abb7n19+t15*t3*t8*abb7n18+t15*t4*t8*abb&
      &7n18+t16*t2*t8*abb7n29+t16*t3*t8*abb7n30+t16*t4*t8*abb7n30+t2*t5*abb7n51*&
      &(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t2*&
      &t5*abb7n52*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak&
      &7k6(4))+t3*t5*t8*abb7n53+t4*t5*t8*abb7n53+t5*t8*abb7n37*(Q(1)*spvak4k1(1)&
      &-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t1*t10*t5*t8*abb7n57&
      &)
      numerator = cmplx(real(d7, ki), aimag(d7), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd7h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d7
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d7 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t12 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t13 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t14 = t2*abb7n33
      t15 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t16 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      d7 = (t1*abb7n20+t14*t3+t14*t4+t2*abb7n23+t2*t2*abb7n34+t3*abb7n24+t4*abb7&
      &n24+t5*abb7n38+t6*abb7n5+t7*abb7n5+t8*abb7n6+t9*abb7n7+t1*t10*abb7n21+t1*&
      &t2*abb7n16+t1*t5*abb7n46+t1*t8*abb7n3+t1*t9*abb7n4+t10*t12*abb7n2+t10*t13&
      &*abb7n9+t10*t2*abb7n32+t10*t3*abb7n31+t10*t4*abb7n31+t10*t5*abb7n40+t10*t&
      &6*abb7n10+t11*t2*abb7n11+t12*t2*abb7n12+t13*t2*abb7n15+t2*t5*abb7n44+t2*t&
      &6*abb7n17+t2*t8*abb7n26+t2*t9*abb7n27+t3*t5*abb7n43+t3*t8*abb7n25+t3*t9*a&
      &bb7n28+t4*t5*abb7n43+t4*t8*abb7n25+t4*t9*abb7n28+t5*t6*abb7n45+t5*t7*abb7&
      &n45+t5*t8*abb7n48+t5*t9*abb7n49+t1*t10*t5*abb7n54+t1*t11*t8*abb7n8+t1*t2*&
      &t5*abb7n50+t1*t2*t8*abb7n13+t1*t3*t8*abb7n14+t1*t4*t8*abb7n14+t1*t5*t9*ab&
      &b7n47+t10*t12*t5*abb7n22+t10*t13*t5*abb7n39+t10*t2*t5*abb7n56+t10*t2*t8*a&
      &bb7n35+t10*t3*t8*abb7n36+t10*t4*t8*abb7n36+t10*t5*t6*abb7n55+t10*t5*t8*ab&
      &b7n41+t11*t5*t8*abb7n42+t15*t2*t8*abb7n19+t15*t3*t8*abb7n18+t15*t4*t8*abb&
      &7n18+t16*t2*t8*abb7n29+t16*t3*t8*abb7n30+t16*t4*t8*abb7n30+t2*t5*abb7n51*&
      &(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t2*&
      &t5*abb7n52*(Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak&
      &7k6(4))+t3*t5*t8*abb7n53+t4*t5*t8*abb7n53+t5*t8*abb7n37*(Q(1)*spvak4k1(1)&
      &-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t1*t10*t5*t8*abb7n57&
      &)

      numerator = cmplx(real(d7, ki), aimag(d7), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d7h1l1
