module     P4B_ddx_ddx_d9h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity1/d9h1l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram9_sign, shift => diagram9_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd9h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d9
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k5-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d9 = 0.0_ki
      t1 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t7 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t8 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = t3*abb9n32
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t4*abb9n34
      t15 = t5*abb9n34
      t16 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t17 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t18 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      t19 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t20 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      d9 = (t1*abb9n10+t11*t12+t11*t13+t11*t4+t11*t5+t12*t14+t12*t15+t13*t14+t13&
      &*t15+t2*abb9n14+t3*abb9n24+t3*t3*abb9n33+t4*abb9n25+t5*abb9n25+t6*abb9n3+&
      &t7*abb9n43+t8*abb9n8+t1*t3*abb9n21+t1*t7*abb9n54+t1*t9*abb9n6+t10*t2*abb9&
      &n9+t10*t3*abb9n28+t10*t4*abb9n29+t10*t5*abb9n29+t10*t7*abb9n46+t12*t2*abb&
      &9n5+t12*t7*abb9n44+t13*t2*abb9n5+t13*t7*abb9n44+t16*t2*abb9n7+t16*t3*abb9&
      &n39+t16*t4*abb9n37+t16*t5*abb9n37+t16*t7*abb9n48+t17*t7*abb9n38+t2*t3*abb&
      &9n20+t2*t7*abb9n52+t2*t9*abb9n13+t3*t6*abb9n12+t3*t7*abb9n53+t3*t8*abb9n1&
      &7+t3*t9*abb9n27+t4*t9*abb9n26+t5*t9*abb9n26+t6*t7*abb9n15+t6*t9*abb9n2+t7&
      &*t8*abb9n41+t7*t9*abb9n45+t8*t9*abb9n4+t1*t7*t9*abb9n56+t10*t16*t2*abb9n1&
      &1+t10*t16*t7*abb9n49+t10*t17*t7*abb9n40+t10*t18*t3*abb9n23+t10*t18*t4*abb&
      &9n22+t10*t18*t5*abb9n22+t10*t19*t3*abb9n30+t10*t19*t4*abb9n31+t10*t19*t5*&
      &abb9n31+t10*t2*t3*abb9n18+t10*t2*t4*abb9n19+t10*t2*t5*abb9n19+t10*t3*t9*a&
      &bb9n35+t10*t4*t7*abb9n61+t10*t4*t9*abb9n36+t10*t5*t7*abb9n61+t10*t5*t9*ab&
      &b9n36+t10*t7*t9*abb9n47+t12*t2*t7*abb9n51+t13*t2*t7*abb9n51+t2*t20*t7*abb&
      &9n59+t2*t3*t7*abb9n50+t2*t7*t9*abb9n55+t20*t3*t7*abb9n60+t3*t7*t9*abb9n57&
      &+t3*t7*abb9n58*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*s&
      &pvak4k6(4))+t6*t7*t9*abb9n16+t7*t8*t9*abb9n42+t10*t2*t7*t9*abb9n62)
      numerator = cmplx(real(d9, ki), aimag(d9), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd9h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d9
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k5-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d9 = 0.0_ki
      t1 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t7 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t8 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = t3*abb9n32
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t4*abb9n34
      t15 = t5*abb9n34
      t16 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t17 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t18 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      t19 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t20 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      d9 = (t1*abb9n10+t11*t12+t11*t13+t11*t4+t11*t5+t12*t14+t12*t15+t13*t14+t13&
      &*t15+t2*abb9n14+t3*abb9n24+t3*t3*abb9n33+t4*abb9n25+t5*abb9n25+t6*abb9n3+&
      &t7*abb9n43+t8*abb9n8+t1*t3*abb9n21+t1*t7*abb9n54+t1*t9*abb9n6+t10*t2*abb9&
      &n9+t10*t3*abb9n28+t10*t4*abb9n29+t10*t5*abb9n29+t10*t7*abb9n46+t12*t2*abb&
      &9n5+t12*t7*abb9n44+t13*t2*abb9n5+t13*t7*abb9n44+t16*t2*abb9n7+t16*t3*abb9&
      &n39+t16*t4*abb9n37+t16*t5*abb9n37+t16*t7*abb9n48+t17*t7*abb9n38+t2*t3*abb&
      &9n20+t2*t7*abb9n52+t2*t9*abb9n13+t3*t6*abb9n12+t3*t7*abb9n53+t3*t8*abb9n1&
      &7+t3*t9*abb9n27+t4*t9*abb9n26+t5*t9*abb9n26+t6*t7*abb9n15+t6*t9*abb9n2+t7&
      &*t8*abb9n41+t7*t9*abb9n45+t8*t9*abb9n4+t1*t7*t9*abb9n56+t10*t16*t2*abb9n1&
      &1+t10*t16*t7*abb9n49+t10*t17*t7*abb9n40+t10*t18*t3*abb9n23+t10*t18*t4*abb&
      &9n22+t10*t18*t5*abb9n22+t10*t19*t3*abb9n30+t10*t19*t4*abb9n31+t10*t19*t5*&
      &abb9n31+t10*t2*t3*abb9n18+t10*t2*t4*abb9n19+t10*t2*t5*abb9n19+t10*t3*t9*a&
      &bb9n35+t10*t4*t7*abb9n61+t10*t4*t9*abb9n36+t10*t5*t7*abb9n61+t10*t5*t9*ab&
      &b9n36+t10*t7*t9*abb9n47+t12*t2*t7*abb9n51+t13*t2*t7*abb9n51+t2*t20*t7*abb&
      &9n59+t2*t3*t7*abb9n50+t2*t7*t9*abb9n55+t20*t3*t7*abb9n60+t3*t7*t9*abb9n57&
      &+t3*t7*abb9n58*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*s&
      &pvak4k6(4))+t6*t7*t9*abb9n16+t7*t8*t9*abb9n42+t10*t2*t7*t9*abb9n62)

      numerator = cmplx(real(d9, ki), aimag(d9), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d9h1l1
