module     P4B_ddx_ddx_golem95h1
   use precision_golem, only: ki_gol => ki
   use P4B_ddx_ddx_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
      module procedure reconstruct_group3
      module procedure reconstruct_group4
      module procedure reconstruct_group5
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use P4B_ddx_ddx_groups, only: tensrec_info_group0
   use P4B_ddx_ddx_d21h1l1, only: numerator_d21 => numerator_golem95
   use P4B_ddx_ddx_d22h1l1, only: numerator_d22 => numerator_golem95
   use P4B_ddx_ddx_d23h1l1, only: numerator_d23 => numerator_golem95
   use P4B_ddx_ddx_d24h1l1, only: numerator_d24 => numerator_golem95
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 21:
      call reconstruct4(numerator_d21, coeffs%coeffs_21)
   !------#] Diagram 21:
   !------#[ Diagram 22:
      call reconstruct4(numerator_d22, coeffs%coeffs_22)
   !------#] Diagram 22:
   !------#[ Diagram 23:
      call reconstruct4(numerator_d23, coeffs%coeffs_23)
   !------#] Diagram 23:
   !------#[ Diagram 24:
      call reconstruct4(numerator_d24, coeffs%coeffs_24)
   !------#] Diagram 24:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use P4B_ddx_ddx_groups, only: tensrec_info_group1
   use P4B_ddx_ddx_d17h1l1, only: numerator_d17 => numerator_golem95
   use P4B_ddx_ddx_d18h1l1, only: numerator_d18 => numerator_golem95
   use P4B_ddx_ddx_d19h1l1, only: numerator_d19 => numerator_golem95
   use P4B_ddx_ddx_d20h1l1, only: numerator_d20 => numerator_golem95
   use P4B_ddx_ddx_d49h1l1, only: numerator_d49 => numerator_golem95
   use P4B_ddx_ddx_d50h1l1, only: numerator_d50 => numerator_golem95
   use P4B_ddx_ddx_d51h1l1, only: numerator_d51 => numerator_golem95
   use P4B_ddx_ddx_d52h1l1, only: numerator_d52 => numerator_golem95
   use P4B_ddx_ddx_d53h1l1, only: numerator_d53 => numerator_golem95
   use P4B_ddx_ddx_d54h1l1, only: numerator_d54 => numerator_golem95
   use P4B_ddx_ddx_d55h1l1, only: numerator_d55 => numerator_golem95
   use P4B_ddx_ddx_d56h1l1, only: numerator_d56 => numerator_golem95
   use P4B_ddx_ddx_d57h1l1, only: numerator_d57 => numerator_golem95
   use P4B_ddx_ddx_d58h1l1, only: numerator_d58 => numerator_golem95
   use P4B_ddx_ddx_d59h1l1, only: numerator_d59 => numerator_golem95
   use P4B_ddx_ddx_d60h1l1, only: numerator_d60 => numerator_golem95
   use P4B_ddx_ddx_d61h1l1, only: numerator_d61 => numerator_golem95
   use P4B_ddx_ddx_d62h1l1, only: numerator_d62 => numerator_golem95
   use P4B_ddx_ddx_d63h1l1, only: numerator_d63 => numerator_golem95
   use P4B_ddx_ddx_d64h1l1, only: numerator_d64 => numerator_golem95
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 17:
      call reconstruct4(numerator_d17, coeffs%coeffs_17)
   !------#] Diagram 17:
   !------#[ Diagram 18:
      call reconstruct4(numerator_d18, coeffs%coeffs_18)
   !------#] Diagram 18:
   !------#[ Diagram 19:
      call reconstruct4(numerator_d19, coeffs%coeffs_19)
   !------#] Diagram 19:
   !------#[ Diagram 20:
      call reconstruct4(numerator_d20, coeffs%coeffs_20)
   !------#] Diagram 20:
   !------#[ Diagram 49:
      call reconstruct3(numerator_d49, coeffs%coeffs_49)
   !------#] Diagram 49:
   !------#[ Diagram 50:
      call reconstruct3(numerator_d50, coeffs%coeffs_50)
   !------#] Diagram 50:
   !------#[ Diagram 51:
      call reconstruct3(numerator_d51, coeffs%coeffs_51)
   !------#] Diagram 51:
   !------#[ Diagram 52:
      call reconstruct3(numerator_d52, coeffs%coeffs_52)
   !------#] Diagram 52:
   !------#[ Diagram 53:
      call reconstruct3(numerator_d53, coeffs%coeffs_53)
   !------#] Diagram 53:
   !------#[ Diagram 54:
      call reconstruct3(numerator_d54, coeffs%coeffs_54)
   !------#] Diagram 54:
   !------#[ Diagram 55:
      call reconstruct3(numerator_d55, coeffs%coeffs_55)
   !------#] Diagram 55:
   !------#[ Diagram 56:
      call reconstruct3(numerator_d56, coeffs%coeffs_56)
   !------#] Diagram 56:
   !------#[ Diagram 57:
      call reconstruct3(numerator_d57, coeffs%coeffs_57)
   !------#] Diagram 57:
   !------#[ Diagram 58:
      call reconstruct3(numerator_d58, coeffs%coeffs_58)
   !------#] Diagram 58:
   !------#[ Diagram 59:
      call reconstruct3(numerator_d59, coeffs%coeffs_59)
   !------#] Diagram 59:
   !------#[ Diagram 60:
      call reconstruct3(numerator_d60, coeffs%coeffs_60)
   !------#] Diagram 60:
   !------#[ Diagram 61:
      call reconstruct3(numerator_d61, coeffs%coeffs_61)
   !------#] Diagram 61:
   !------#[ Diagram 62:
      call reconstruct3(numerator_d62, coeffs%coeffs_62)
   !------#] Diagram 62:
   !------#[ Diagram 63:
      call reconstruct3(numerator_d63, coeffs%coeffs_63)
   !------#] Diagram 63:
   !------#[ Diagram 64:
      call reconstruct3(numerator_d64, coeffs%coeffs_64)
   !------#] Diagram 64:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use P4B_ddx_ddx_groups, only: tensrec_info_group2
   use P4B_ddx_ddx_d13h1l1, only: numerator_d13 => numerator_golem95
   use P4B_ddx_ddx_d14h1l1, only: numerator_d14 => numerator_golem95
   use P4B_ddx_ddx_d15h1l1, only: numerator_d15 => numerator_golem95
   use P4B_ddx_ddx_d16h1l1, only: numerator_d16 => numerator_golem95
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 13:
      call reconstruct4(numerator_d13, coeffs%coeffs_13)
   !------#] Diagram 13:
   !------#[ Diagram 14:
      call reconstruct4(numerator_d14, coeffs%coeffs_14)
   !------#] Diagram 14:
   !------#[ Diagram 15:
      call reconstruct4(numerator_d15, coeffs%coeffs_15)
   !------#] Diagram 15:
   !------#[ Diagram 16:
      call reconstruct4(numerator_d16, coeffs%coeffs_16)
   !------#] Diagram 16:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
!---#[ subroutine reconstruct_group3:
subroutine     reconstruct_group3(coeffs)
   use tens_rec
   use P4B_ddx_ddx_groups, only: tensrec_info_group3
   use P4B_ddx_ddx_d9h1l1, only: numerator_d9 => numerator_golem95
   use P4B_ddx_ddx_d10h1l1, only: numerator_d10 => numerator_golem95
   use P4B_ddx_ddx_d11h1l1, only: numerator_d11 => numerator_golem95
   use P4B_ddx_ddx_d12h1l1, only: numerator_d12 => numerator_golem95
   implicit none
   type(tensrec_info_group3), intent(out) :: coeffs
   !------#[ Diagram 9:
      call reconstruct4(numerator_d9, coeffs%coeffs_9)
   !------#] Diagram 9:
   !------#[ Diagram 10:
      call reconstruct4(numerator_d10, coeffs%coeffs_10)
   !------#] Diagram 10:
   !------#[ Diagram 11:
      call reconstruct4(numerator_d11, coeffs%coeffs_11)
   !------#] Diagram 11:
   !------#[ Diagram 12:
      call reconstruct4(numerator_d12, coeffs%coeffs_12)
   !------#] Diagram 12:
end subroutine reconstruct_group3
!---#] subroutine reconstruct_group3:
!---#[ subroutine reconstruct_group4:
subroutine     reconstruct_group4(coeffs)
   use tens_rec
   use P4B_ddx_ddx_groups, only: tensrec_info_group4
   use P4B_ddx_ddx_d1h1l1, only: numerator_d1 => numerator_golem95
   use P4B_ddx_ddx_d2h1l1, only: numerator_d2 => numerator_golem95
   use P4B_ddx_ddx_d3h1l1, only: numerator_d3 => numerator_golem95
   use P4B_ddx_ddx_d4h1l1, only: numerator_d4 => numerator_golem95
   implicit none
   type(tensrec_info_group4), intent(out) :: coeffs
   !------#[ Diagram 1:
      call reconstruct4(numerator_d1, coeffs%coeffs_1)
   !------#] Diagram 1:
   !------#[ Diagram 2:
      call reconstruct4(numerator_d2, coeffs%coeffs_2)
   !------#] Diagram 2:
   !------#[ Diagram 3:
      call reconstruct4(numerator_d3, coeffs%coeffs_3)
   !------#] Diagram 3:
   !------#[ Diagram 4:
      call reconstruct4(numerator_d4, coeffs%coeffs_4)
   !------#] Diagram 4:
end subroutine reconstruct_group4
!---#] subroutine reconstruct_group4:
!---#[ subroutine reconstruct_group5:
subroutine     reconstruct_group5(coeffs)
   use tens_rec
   use P4B_ddx_ddx_groups, only: tensrec_info_group5
   use P4B_ddx_ddx_d5h1l1, only: numerator_d5 => numerator_golem95
   use P4B_ddx_ddx_d6h1l1, only: numerator_d6 => numerator_golem95
   use P4B_ddx_ddx_d7h1l1, only: numerator_d7 => numerator_golem95
   use P4B_ddx_ddx_d8h1l1, only: numerator_d8 => numerator_golem95
   use P4B_ddx_ddx_d33h1l1, only: numerator_d33 => numerator_golem95
   use P4B_ddx_ddx_d34h1l1, only: numerator_d34 => numerator_golem95
   use P4B_ddx_ddx_d35h1l1, only: numerator_d35 => numerator_golem95
   use P4B_ddx_ddx_d36h1l1, only: numerator_d36 => numerator_golem95
   use P4B_ddx_ddx_d37h1l1, only: numerator_d37 => numerator_golem95
   use P4B_ddx_ddx_d38h1l1, only: numerator_d38 => numerator_golem95
   use P4B_ddx_ddx_d39h1l1, only: numerator_d39 => numerator_golem95
   use P4B_ddx_ddx_d40h1l1, only: numerator_d40 => numerator_golem95
   use P4B_ddx_ddx_d41h1l1, only: numerator_d41 => numerator_golem95
   use P4B_ddx_ddx_d42h1l1, only: numerator_d42 => numerator_golem95
   use P4B_ddx_ddx_d43h1l1, only: numerator_d43 => numerator_golem95
   use P4B_ddx_ddx_d44h1l1, only: numerator_d44 => numerator_golem95
   use P4B_ddx_ddx_d45h1l1, only: numerator_d45 => numerator_golem95
   use P4B_ddx_ddx_d46h1l1, only: numerator_d46 => numerator_golem95
   use P4B_ddx_ddx_d47h1l1, only: numerator_d47 => numerator_golem95
   use P4B_ddx_ddx_d48h1l1, only: numerator_d48 => numerator_golem95
   implicit none
   type(tensrec_info_group5), intent(out) :: coeffs
   !------#[ Diagram 5:
      call reconstruct4(numerator_d5, coeffs%coeffs_5)
   !------#] Diagram 5:
   !------#[ Diagram 6:
      call reconstruct4(numerator_d6, coeffs%coeffs_6)
   !------#] Diagram 6:
   !------#[ Diagram 7:
      call reconstruct4(numerator_d7, coeffs%coeffs_7)
   !------#] Diagram 7:
   !------#[ Diagram 8:
      call reconstruct4(numerator_d8, coeffs%coeffs_8)
   !------#] Diagram 8:
   !------#[ Diagram 33:
      call reconstruct3(numerator_d33, coeffs%coeffs_33)
   !------#] Diagram 33:
   !------#[ Diagram 34:
      call reconstruct3(numerator_d34, coeffs%coeffs_34)
   !------#] Diagram 34:
   !------#[ Diagram 35:
      call reconstruct3(numerator_d35, coeffs%coeffs_35)
   !------#] Diagram 35:
   !------#[ Diagram 36:
      call reconstruct3(numerator_d36, coeffs%coeffs_36)
   !------#] Diagram 36:
   !------#[ Diagram 37:
      call reconstruct3(numerator_d37, coeffs%coeffs_37)
   !------#] Diagram 37:
   !------#[ Diagram 38:
      call reconstruct3(numerator_d38, coeffs%coeffs_38)
   !------#] Diagram 38:
   !------#[ Diagram 39:
      call reconstruct3(numerator_d39, coeffs%coeffs_39)
   !------#] Diagram 39:
   !------#[ Diagram 40:
      call reconstruct3(numerator_d40, coeffs%coeffs_40)
   !------#] Diagram 40:
   !------#[ Diagram 41:
      call reconstruct3(numerator_d41, coeffs%coeffs_41)
   !------#] Diagram 41:
   !------#[ Diagram 42:
      call reconstruct3(numerator_d42, coeffs%coeffs_42)
   !------#] Diagram 42:
   !------#[ Diagram 43:
      call reconstruct3(numerator_d43, coeffs%coeffs_43)
   !------#] Diagram 43:
   !------#[ Diagram 44:
      call reconstruct3(numerator_d44, coeffs%coeffs_44)
   !------#] Diagram 44:
   !------#[ Diagram 45:
      call reconstruct3(numerator_d45, coeffs%coeffs_45)
   !------#] Diagram 45:
   !------#[ Diagram 46:
      call reconstruct3(numerator_d46, coeffs%coeffs_46)
   !------#] Diagram 46:
   !------#[ Diagram 47:
      call reconstruct3(numerator_d47, coeffs%coeffs_47)
   !------#] Diagram 47:
   !------#[ Diagram 48:
      call reconstruct3(numerator_d48, coeffs%coeffs_48)
   !------#] Diagram 48:
end subroutine reconstruct_group5
!---#] subroutine reconstruct_group5:
end module P4B_ddx_ddx_golem95h1
