module     P4B_ddx_ddx_d11h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity3/d11h3l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram11_sign, shift => diagram11_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd11h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k5-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d11 = 0.0_ki
      t1 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t7 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t8 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t3*abb11n32
      t15 = t4*abb11n34
      t16 = t5*abb11n34
      t17 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t18 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t19 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      d11 = (t1*abb11n10+t12*t14+t12*t15+t12*t16+t13*t14+t13*t15+t13*t16+t14*t4+&
      &t14*t5+t2*abb11n16+t3*abb11n19+t3*t3*abb11n33+t4*abb11n20+t5*abb11n20+t6*&
      &abb11n41+t7*abb11n7+t8*abb11n9+t1*t3*abb11n31+t1*t6*abb11n54+t1*t9*abb11n&
      &5+t10*t2*abb11n8+t10*t3*abb11n23+t10*t4*abb11n24+t10*t5*abb11n24+t10*t6*a&
      &bb11n44+t11*t2*abb11n6+t11*t3*abb11n48+t11*t4*abb11n46+t11*t5*abb11n46+t1&
      &1*t6*abb11n27+t12*t2*abb11n3+t12*t6*abb11n42+t13*t2*abb11n3+t13*t6*abb11n&
      &42+t17*t6*abb11n47+t2*t3*abb11n29+t2*t6*abb11n52+t2*t9*abb11n12+t3*t6*abb&
      &11n53+t3*t7*abb11n13+t3*t8*abb11n30+t3*t9*abb11n22+t4*t9*abb11n21+t5*t9*a&
      &bb11n21+t6*t7*abb11n14+t6*t8*abb11n37+t6*t9*abb11n43+t7*t9*abb11n2+t8*t9*&
      &abb11n4+t1*t6*t9*abb11n56+t10*t11*t2*abb11n11+t10*t11*t6*abb11n28+t10*t17&
      &*t6*abb11n49+t10*t18*t3*abb11n25+t10*t18*t4*abb11n26+t10*t18*t5*abb11n26+&
      &t10*t2*t3*abb11n17+t10*t2*t4*abb11n18+t10*t2*t5*abb11n18+t10*t3*t7*abb11n&
      &40+t10*t3*t9*abb11n35+t10*t4*t6*abb11n61+t10*t4*t7*abb11n39+t10*t4*t9*abb&
      &11n36+t10*t5*t6*abb11n61+t10*t5*t7*abb11n39+t10*t5*t9*abb11n36+t10*t6*t9*&
      &abb11n45+t12*t2*t6*abb11n51+t13*t2*t6*abb11n51+t19*t2*t6*abb11n59+t19*t3*&
      &t6*abb11n60+t2*t3*t6*abb11n50+t2*t6*t9*abb11n55+t3*t6*t9*abb11n57+t3*t6*a&
      &bb11n58*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6&
      &(4))+t6*t7*t9*abb11n15+t6*t8*t9*abb11n38+t10*t2*t6*t9*abb11n62)
      numerator = cmplx(real(d11, ki), aimag(d11), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd11h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d11
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k5-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d11 = 0.0_ki
      t1 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t7 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t8 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4)&
      &)
      t11 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t12 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = t3*abb11n32
      t15 = t4*abb11n34
      t16 = t5*abb11n34
      t17 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4)&
      &)
      t18 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t19 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      d11 = (t1*abb11n10+t12*t14+t12*t15+t12*t16+t13*t14+t13*t15+t13*t16+t14*t4+&
      &t14*t5+t2*abb11n16+t3*abb11n19+t3*t3*abb11n33+t4*abb11n20+t5*abb11n20+t6*&
      &abb11n41+t7*abb11n7+t8*abb11n9+t1*t3*abb11n31+t1*t6*abb11n54+t1*t9*abb11n&
      &5+t10*t2*abb11n8+t10*t3*abb11n23+t10*t4*abb11n24+t10*t5*abb11n24+t10*t6*a&
      &bb11n44+t11*t2*abb11n6+t11*t3*abb11n48+t11*t4*abb11n46+t11*t5*abb11n46+t1&
      &1*t6*abb11n27+t12*t2*abb11n3+t12*t6*abb11n42+t13*t2*abb11n3+t13*t6*abb11n&
      &42+t17*t6*abb11n47+t2*t3*abb11n29+t2*t6*abb11n52+t2*t9*abb11n12+t3*t6*abb&
      &11n53+t3*t7*abb11n13+t3*t8*abb11n30+t3*t9*abb11n22+t4*t9*abb11n21+t5*t9*a&
      &bb11n21+t6*t7*abb11n14+t6*t8*abb11n37+t6*t9*abb11n43+t7*t9*abb11n2+t8*t9*&
      &abb11n4+t1*t6*t9*abb11n56+t10*t11*t2*abb11n11+t10*t11*t6*abb11n28+t10*t17&
      &*t6*abb11n49+t10*t18*t3*abb11n25+t10*t18*t4*abb11n26+t10*t18*t5*abb11n26+&
      &t10*t2*t3*abb11n17+t10*t2*t4*abb11n18+t10*t2*t5*abb11n18+t10*t3*t7*abb11n&
      &40+t10*t3*t9*abb11n35+t10*t4*t6*abb11n61+t10*t4*t7*abb11n39+t10*t4*t9*abb&
      &11n36+t10*t5*t6*abb11n61+t10*t5*t7*abb11n39+t10*t5*t9*abb11n36+t10*t6*t9*&
      &abb11n45+t12*t2*t6*abb11n51+t13*t2*t6*abb11n51+t19*t2*t6*abb11n59+t19*t3*&
      &t6*abb11n60+t2*t3*t6*abb11n50+t2*t6*t9*abb11n55+t3*t6*t9*abb11n57+t3*t6*a&
      &bb11n58*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6&
      &(4))+t6*t7*t9*abb11n15+t6*t8*t9*abb11n38+t10*t2*t6*t9*abb11n62)

      numerator = cmplx(real(d11, ki), aimag(d11), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d11h3l1
