module     P4B_ddx_ddx_d35h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity3/d35h3l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram35_sign, shift => diagram35_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd35h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d35
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d35 = 0.0_ki
      t1 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = t3*abb35n16
      t13 = t3*abb35n17
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t16 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t17 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t18 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t19 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t20 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t21 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t22 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t23 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t24 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t25 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      d35 = (t1*abb35n10+t12*t8+t12*t9+t13*t5+t13*t7+t2*abb35n11+t3*abb35n36+t4*&
      &abb35n5+t1*t14*abb35n39+t1*t15*abb35n39+t1*t24*abb35n52+t1*t3*abb35n40+t1&
      &0*t14*abb35n18+t10*t15*abb35n18+t10*t25*abb35n8+t10*t3*abb35n19+t10*t6*ab&
      &b35n14+t11*t14*abb35n21+t11*t15*abb35n21+t11*t25*abb35n9+t11*t3*abb35n20+&
      &t11*t6*abb35n15+t14*t16*abb35n22+t14*t17*abb35n24+t14*t18*abb35n27+t14*t1&
      &9*abb35n29+t14*t20*abb35n30+t14*t21*abb35n32+t14*t22*abb35n35+t14*t23*abb&
      &35n38+t14*t24*abb35n50+t15*t16*abb35n22+t15*t17*abb35n24+t15*t18*abb35n27&
      &+t15*t19*abb35n29+t15*t20*abb35n30+t15*t21*abb35n32+t15*t22*abb35n35+t15*&
      &t23*abb35n38+t15*t24*abb35n50+t16*t24*abb35n41+t16*t3*abb35n23+t17*t24*ab&
      &b35n42+t17*t3*abb35n25+t18*t24*abb35n43+t18*t3*abb35n26+t19*t24*abb35n44+&
      &t19*t3*abb35n28+t2*t24*abb35n51+t20*t24*abb35n46+t20*t3*abb35n31+t21*t24*&
      &abb35n45+t21*t3*abb35n33+t22*t24*abb35n48+t22*t3*abb35n34+t23*t24*abb35n4&
      &7+t23*t3*abb35n37+t24*t3*abb35n49+t24*t4*abb35n51+t25*t5*abb35n7+t25*t7*a&
      &bb35n7+t25*t8*abb35n6+t25*t9*abb35n6+t5*t6*abb35n12+t6*t7*abb35n12+t6*t8*&
      &abb35n13+t6*t9*abb35n13+t1*t10*t24*abb35n55+t1*t11*t24*abb35n56+t1*t24*t5&
      &*abb35n53+t1*t24*t7*abb35n53+t1*t24*t8*abb35n54+t1*t24*t9*abb35n54)
      numerator = cmplx(real(d35, ki), aimag(d35), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd35h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d35
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d35 = 0.0_ki
      t1 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t5 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t6 = (Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2k3(3)-Q(4)*spvak2k3(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t10 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = t3*abb35n16
      t13 = t3*abb35n17
      t14 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t15 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t16 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t17 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t18 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t19 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      t20 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t21 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t22 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t23 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t24 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t25 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      d35 = (t1*abb35n10+t12*t8+t12*t9+t13*t5+t13*t7+t2*abb35n11+t3*abb35n36+t4*&
      &abb35n5+t1*t14*abb35n39+t1*t15*abb35n39+t1*t24*abb35n52+t1*t3*abb35n40+t1&
      &0*t14*abb35n18+t10*t15*abb35n18+t10*t25*abb35n8+t10*t3*abb35n19+t10*t6*ab&
      &b35n14+t11*t14*abb35n21+t11*t15*abb35n21+t11*t25*abb35n9+t11*t3*abb35n20+&
      &t11*t6*abb35n15+t14*t16*abb35n22+t14*t17*abb35n24+t14*t18*abb35n27+t14*t1&
      &9*abb35n29+t14*t20*abb35n30+t14*t21*abb35n32+t14*t22*abb35n35+t14*t23*abb&
      &35n38+t14*t24*abb35n50+t15*t16*abb35n22+t15*t17*abb35n24+t15*t18*abb35n27&
      &+t15*t19*abb35n29+t15*t20*abb35n30+t15*t21*abb35n32+t15*t22*abb35n35+t15*&
      &t23*abb35n38+t15*t24*abb35n50+t16*t24*abb35n41+t16*t3*abb35n23+t17*t24*ab&
      &b35n42+t17*t3*abb35n25+t18*t24*abb35n43+t18*t3*abb35n26+t19*t24*abb35n44+&
      &t19*t3*abb35n28+t2*t24*abb35n51+t20*t24*abb35n46+t20*t3*abb35n31+t21*t24*&
      &abb35n45+t21*t3*abb35n33+t22*t24*abb35n48+t22*t3*abb35n34+t23*t24*abb35n4&
      &7+t23*t3*abb35n37+t24*t3*abb35n49+t24*t4*abb35n51+t25*t5*abb35n7+t25*t7*a&
      &bb35n7+t25*t8*abb35n6+t25*t9*abb35n6+t5*t6*abb35n12+t6*t7*abb35n12+t6*t8*&
      &abb35n13+t6*t9*abb35n13+t1*t10*t24*abb35n55+t1*t11*t24*abb35n56+t1*t24*t5&
      &*abb35n53+t1*t24*t7*abb35n53+t1*t24*t8*abb35n54+t1*t24*t9*abb35n54)

      numerator = cmplx(real(d35, ki), aimag(d35), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d35h3l1
