module     P4B_ddx_ddx_d15h4l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity4/d15h4l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram15_sign, shift => diagram15_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd15h4
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d15
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d15 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t10 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t11 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t12 = t3*abb15n29
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t16 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      d15 = (t1*abb15n12+t10*abb15n7+t11*abb15n8+t12*t6+t12*t7+t12*t8+t2*abb15n2&
      &1+t3*abb15n23+t3*t3*abb15n30+t4*abb15n3+t5*abb15n4+t6*abb15n5+t7*abb15n5+&
      &t8*abb15n5+t9*abb15n6+t1*t10*abb15n14+t1*t11*abb15n19+t1*t3*abb15n33+t1*t&
      &4*abb15n11+t1*t9*abb15n13+t10*t13*abb15n47+t10*t2*abb15n9+t11*t13*abb15n5&
      &3+t11*t2*abb15n32+t11*t3*abb15n16+t11*t4*abb15n26+t11*t5*abb15n15+t11*t6*&
      &abb15n17+t11*t7*abb15n17+t11*t8*abb15n17+t13*t14*abb15n39+t13*t2*abb15n37&
      &+t13*t3*abb15n46+t13*t4*abb15n34+t13*t5*abb15n35+t13*t6*abb15n36+t13*t7*a&
      &bb15n36+t13*t8*abb15n36+t13*t9*abb15n45+t2*t3*abb15n28+t2*t4*abb15n2+t2*t&
      &9*abb15n10+t3*t4*abb15n24+t3*t5*abb15n31+t1*t11*t4*abb15n18+t10*t11*t13*a&
      &bb15n62+t10*t13*t15*abb15n44+t10*t13*t16*abb15n54+t10*t13*t2*abb15n48+t10&
      &*t13*t4*abb15n40+t11*t13*t14*abb15n57+t11*t13*t2*abb15n64+t11*t13*t3*abb1&
      &5n61+t11*t13*t4*abb15n52+t11*t13*t5*abb15n63+t11*t13*t6*abb15n59+t11*t13*&
      &t7*abb15n59+t11*t13*t8*abb15n59+t11*t13*t9*abb15n60+t11*t13*abb15n51*(Q(1&
      &)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t11*t13&
      &*abb15n58*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5&
      &k8(4))+t11*t3*t4*abb15n27+t13*t14*t4*abb15n38+t13*t15*t3*abb15n43+t13*t15&
      &*t9*abb15n42+t13*t16*t3*abb15n55+t13*t16*t9*abb15n56+t13*t2*t3*abb15n49+t&
      &13*t2*t9*abb15n50+t13*t4*t9*abb15n41+t14*t3*t4*abb15n25+t2*t3*t4*abb15n20&
      &+t3*t4*abb15n22*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*&
      &spvak2k6(4))+t11*t13*t2*t4*abb15n65)
      numerator = cmplx(real(d15, ki), aimag(d15), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd15h4
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d15
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d15 = 0.0_ki
      t1 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t2 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t10 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t11 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t12 = t3*abb15n29
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t16 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      d15 = (t1*abb15n12+t10*abb15n7+t11*abb15n8+t12*t6+t12*t7+t12*t8+t2*abb15n2&
      &1+t3*abb15n23+t3*t3*abb15n30+t4*abb15n3+t5*abb15n4+t6*abb15n5+t7*abb15n5+&
      &t8*abb15n5+t9*abb15n6+t1*t10*abb15n14+t1*t11*abb15n19+t1*t3*abb15n33+t1*t&
      &4*abb15n11+t1*t9*abb15n13+t10*t13*abb15n47+t10*t2*abb15n9+t11*t13*abb15n5&
      &3+t11*t2*abb15n32+t11*t3*abb15n16+t11*t4*abb15n26+t11*t5*abb15n15+t11*t6*&
      &abb15n17+t11*t7*abb15n17+t11*t8*abb15n17+t13*t14*abb15n39+t13*t2*abb15n37&
      &+t13*t3*abb15n46+t13*t4*abb15n34+t13*t5*abb15n35+t13*t6*abb15n36+t13*t7*a&
      &bb15n36+t13*t8*abb15n36+t13*t9*abb15n45+t2*t3*abb15n28+t2*t4*abb15n2+t2*t&
      &9*abb15n10+t3*t4*abb15n24+t3*t5*abb15n31+t1*t11*t4*abb15n18+t10*t11*t13*a&
      &bb15n62+t10*t13*t15*abb15n44+t10*t13*t16*abb15n54+t10*t13*t2*abb15n48+t10&
      &*t13*t4*abb15n40+t11*t13*t14*abb15n57+t11*t13*t2*abb15n64+t11*t13*t3*abb1&
      &5n61+t11*t13*t4*abb15n52+t11*t13*t5*abb15n63+t11*t13*t6*abb15n59+t11*t13*&
      &t7*abb15n59+t11*t13*t8*abb15n59+t11*t13*t9*abb15n60+t11*t13*abb15n51*(Q(1&
      &)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t11*t13&
      &*abb15n58*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5&
      &k8(4))+t11*t3*t4*abb15n27+t13*t14*t4*abb15n38+t13*t15*t3*abb15n43+t13*t15&
      &*t9*abb15n42+t13*t16*t3*abb15n55+t13*t16*t9*abb15n56+t13*t2*t3*abb15n49+t&
      &13*t2*t9*abb15n50+t13*t4*t9*abb15n41+t14*t3*t4*abb15n25+t2*t3*t4*abb15n20&
      &+t3*t4*abb15n22*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*&
      &spvak2k6(4))+t11*t13*t2*t4*abb15n65)

      numerator = cmplx(real(d15, ki), aimag(d15), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d15h4l1
