module     P4B_ddx_ddx_d18h5l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity5/d18h5l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram18_sign, shift => diagram18_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd18h5
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d18
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d18 = 0.0_ki
      t1 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t11 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t12 = t4*abb18n28
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t15 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t16 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      d18 = (t1*abb18n10+t10*abb18n8+t11*abb18n9+t12*t5+t12*t6+t12*t7+t2*abb18n1&
      &4+t3*abb18n17+t4*abb18n24+t4*t4*abb18n27+t5*abb18n5+t6*abb18n5+t7*abb18n5&
      &+t8*abb18n6+t9*abb18n7+t1*t10*abb18n12+t1*t11*abb18n13+t1*t3*abb18n21+t1*&
      &t4*abb18n39+t1*t9*abb18n11+t10*t13*abb18n47+t10*t2*abb18n3+t11*t13*abb18n&
      &49+t11*t2*abb18n4+t13*t14*abb18n35+t13*t2*abb18n34+t13*t3*abb18n56+t13*t4&
      &*abb18n48+t13*t5*abb18n32+t13*t6*abb18n32+t13*t7*abb18n32+t13*t8*abb18n33&
      &+t13*t9*abb18n36+t2*t3*abb18n23+t2*t4*abb18n25+t2*t9*abb18n2+t3*t4*abb18n&
      &19+t3*t5*abb18n18+t3*t6*abb18n18+t3*t7*abb18n18+t3*t8*abb18n20+t3*t9*abb1&
      &8n30+t4*t8*abb18n26+t4*t9*abb18n29+t1*t3*t9*abb18n22+t1*t4*t9*abb18n46+t1&
      &0*t13*t15*abb18n45+t10*t13*t16*abb18n50+t10*t13*t2*abb18n40+t10*t13*t3*ab&
      &b18n61+t10*t13*t9*abb18n53+t11*t13*t15*abb18n43+t11*t13*t16*abb18n52+t11*&
      &t13*t2*abb18n42+t11*t13*t3*abb18n59+t11*t13*t9*abb18n54+t13*t14*t3*abb18n&
      &38+t13*t14*t9*abb18n37+t13*t15*t4*abb18n44+t13*t16*t3*abb18n63+t13*t16*t4&
      &*abb18n51+t13*t2*t3*abb18n64+t13*t2*t4*abb18n41+t13*t3*t4*abb18n60+t13*t3&
      &*t5*abb18n58+t13*t3*t6*abb18n58+t13*t3*t7*abb18n58+t13*t3*t8*abb18n62+t13&
      &*t3*t9*abb18n55+t13*t3*abb18n57*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*s&
      &pvak7k4(3)-Q(4)*spvak7k4(4))+t2*t4*t9*abb18n15+t3*t4*t9*abb18n31+t4*t9*ab&
      &b18n16*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(&
      &4))+t13*t2*t3*t9*abb18n65)
      numerator = cmplx(real(d18, ki), aimag(d18), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd18h5
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d18
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d18 = 0.0_ki
      t1 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t2 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t3 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t10 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t11 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t12 = t4*abb18n28
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t14 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t15 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t16 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      d18 = (t1*abb18n10+t10*abb18n8+t11*abb18n9+t12*t5+t12*t6+t12*t7+t2*abb18n1&
      &4+t3*abb18n17+t4*abb18n24+t4*t4*abb18n27+t5*abb18n5+t6*abb18n5+t7*abb18n5&
      &+t8*abb18n6+t9*abb18n7+t1*t10*abb18n12+t1*t11*abb18n13+t1*t3*abb18n21+t1*&
      &t4*abb18n39+t1*t9*abb18n11+t10*t13*abb18n47+t10*t2*abb18n3+t11*t13*abb18n&
      &49+t11*t2*abb18n4+t13*t14*abb18n35+t13*t2*abb18n34+t13*t3*abb18n56+t13*t4&
      &*abb18n48+t13*t5*abb18n32+t13*t6*abb18n32+t13*t7*abb18n32+t13*t8*abb18n33&
      &+t13*t9*abb18n36+t2*t3*abb18n23+t2*t4*abb18n25+t2*t9*abb18n2+t3*t4*abb18n&
      &19+t3*t5*abb18n18+t3*t6*abb18n18+t3*t7*abb18n18+t3*t8*abb18n20+t3*t9*abb1&
      &8n30+t4*t8*abb18n26+t4*t9*abb18n29+t1*t3*t9*abb18n22+t1*t4*t9*abb18n46+t1&
      &0*t13*t15*abb18n45+t10*t13*t16*abb18n50+t10*t13*t2*abb18n40+t10*t13*t3*ab&
      &b18n61+t10*t13*t9*abb18n53+t11*t13*t15*abb18n43+t11*t13*t16*abb18n52+t11*&
      &t13*t2*abb18n42+t11*t13*t3*abb18n59+t11*t13*t9*abb18n54+t13*t14*t3*abb18n&
      &38+t13*t14*t9*abb18n37+t13*t15*t4*abb18n44+t13*t16*t3*abb18n63+t13*t16*t4&
      &*abb18n51+t13*t2*t3*abb18n64+t13*t2*t4*abb18n41+t13*t3*t4*abb18n60+t13*t3&
      &*t5*abb18n58+t13*t3*t6*abb18n58+t13*t3*t7*abb18n58+t13*t3*t8*abb18n62+t13&
      &*t3*t9*abb18n55+t13*t3*abb18n57*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*s&
      &pvak7k4(3)-Q(4)*spvak7k4(4))+t2*t4*t9*abb18n15+t3*t4*t9*abb18n31+t4*t9*ab&
      &b18n16*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(&
      &4))+t13*t2*t3*t9*abb18n65)

      numerator = cmplx(real(d18, ki), aimag(d18), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d18h5l1
