module     P4B_ddx_ddx_d19h5l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity5/d19h5l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram19_sign, shift => diagram19_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd19h5
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d19
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d19 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t4 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t8 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t11 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t12 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t13 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t14 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d19 = (t1*abb19n10+t2*abb19n27+t2*t2*abb19n39+t3*abb19n4+t4*abb19n4+t5*abb&
      &19n44+t6*abb19n5+t7*abb19n6+t8*abb19n8+t9*abb19n9+t1*t10*abb19n33+t1*t2*a&
      &bb19n40+t1*t5*abb19n45+t1*t6*abb19n11+t1*t7*abb19n16+t10*t11*abb19n23+t10&
      &*t12*abb19n24+t10*t2*abb19n32+t10*t3*abb19n25+t10*t5*abb19n62+t10*t8*abb1&
      &9n30+t10*t9*abb19n31+t11*t2*abb19n28+t12*t2*abb19n36+t13*t2*abb19n26+t2*t&
      &3*abb19n37+t2*t5*abb19n46+t2*t6*abb19n12+t2*t7*abb19n15+t2*t8*abb19n35+t2&
      &*t9*abb19n38+t3*t5*abb19n45+t4*t5*abb19n45+t5*t6*abb19n50+t5*t7*abb19n51+&
      &t5*t8*abb19n48+t5*t9*abb19n47+t6*t8*abb19n2+t6*t9*abb19n13+t7*t8*abb19n3+&
      &t7*t9*abb19n14+t1*t10*t6*abb19n41+t1*t11*t6*abb19n56+t1*t14*t6*abb19n20+t&
      &1*t5*t6*abb19n60+t1*t6*t8*abb19n17+t10*t11*t5*abb19n29+t10*t12*t5*abb19n6&
      &1+t10*t2*t5*abb19n66+t10*t2*t6*abb19n42+t10*t3*t5*abb19n65+t10*t5*t6*abb1&
      &9n63+t10*t5*t8*abb19n64+t10*t6*t9*abb19n43+t11*t2*t6*abb19n55+t11*t6*t9*a&
      &bb19n54+t13*t5*t6*abb19n34+t13*t6*t8*abb19n7+t14*t2*t6*abb19n21+t14*t6*t9&
      &*abb19n22+t2*t5*t8*abb19n52+t2*t5*abb19n53*(Q(1)*spvak5k8(1)-Q(2)*spvak5k&
      &8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t2*t5*abb19n58*(Q(1)*spvak7k6(1)-&
      &Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4))+t2*t6*t8*abb19n18+t5*&
      &t6*t9*abb19n59+t5*t6*abb19n57*(Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spv&
      &ak4k3(3)-Q(4)*spvak4k3(4))+t5*t7*t8*abb19n49+t6*t8*t9*abb19n19+t10*t5*t6*&
      &t8*abb19n67)
      numerator = cmplx(real(d19, ki), aimag(d19), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd19h5
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d19
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d19 = 0.0_ki
      t1 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t4 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t8 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t9 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t10 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t11 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t12 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t13 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t14 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d19 = (t1*abb19n10+t2*abb19n27+t2*t2*abb19n39+t3*abb19n4+t4*abb19n4+t5*abb&
      &19n44+t6*abb19n5+t7*abb19n6+t8*abb19n8+t9*abb19n9+t1*t10*abb19n33+t1*t2*a&
      &bb19n40+t1*t5*abb19n45+t1*t6*abb19n11+t1*t7*abb19n16+t10*t11*abb19n23+t10&
      &*t12*abb19n24+t10*t2*abb19n32+t10*t3*abb19n25+t10*t5*abb19n62+t10*t8*abb1&
      &9n30+t10*t9*abb19n31+t11*t2*abb19n28+t12*t2*abb19n36+t13*t2*abb19n26+t2*t&
      &3*abb19n37+t2*t5*abb19n46+t2*t6*abb19n12+t2*t7*abb19n15+t2*t8*abb19n35+t2&
      &*t9*abb19n38+t3*t5*abb19n45+t4*t5*abb19n45+t5*t6*abb19n50+t5*t7*abb19n51+&
      &t5*t8*abb19n48+t5*t9*abb19n47+t6*t8*abb19n2+t6*t9*abb19n13+t7*t8*abb19n3+&
      &t7*t9*abb19n14+t1*t10*t6*abb19n41+t1*t11*t6*abb19n56+t1*t14*t6*abb19n20+t&
      &1*t5*t6*abb19n60+t1*t6*t8*abb19n17+t10*t11*t5*abb19n29+t10*t12*t5*abb19n6&
      &1+t10*t2*t5*abb19n66+t10*t2*t6*abb19n42+t10*t3*t5*abb19n65+t10*t5*t6*abb1&
      &9n63+t10*t5*t8*abb19n64+t10*t6*t9*abb19n43+t11*t2*t6*abb19n55+t11*t6*t9*a&
      &bb19n54+t13*t5*t6*abb19n34+t13*t6*t8*abb19n7+t14*t2*t6*abb19n21+t14*t6*t9&
      &*abb19n22+t2*t5*t8*abb19n52+t2*t5*abb19n53*(Q(1)*spvak5k8(1)-Q(2)*spvak5k&
      &8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4))+t2*t5*abb19n58*(Q(1)*spvak7k6(1)-&
      &Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4))+t2*t6*t8*abb19n18+t5*&
      &t6*t9*abb19n59+t5*t6*abb19n57*(Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spv&
      &ak4k3(3)-Q(4)*spvak4k3(4))+t5*t7*t8*abb19n49+t6*t8*t9*abb19n19+t10*t5*t6*&
      &t8*abb19n67)

      numerator = cmplx(real(d19, ki), aimag(d19), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d19h5l1
