module     P4B_ddx_ddx_d22h5l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity5/d22h5l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram22_sign, shift => diagram22_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd22h5
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d22
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6-k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d22 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t3 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = t5*abb22n25
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d22 = (t1*abb22n10+t10*abb22n9+t11*abb22n9+t12*t7+t12*t8+t12*t9+t2*abb22n1&
      &1+t3*abb22n12+t4*abb22n18+t5*abb22n26+t5*t5*abb22n24+t6*abb22n7+t7*abb22n&
      &8+t8*abb22n8+t9*abb22n8+t1*t13*abb22n33+t1*t2*abb22n28+t1*t3*abb22n14+t1*&
      &t4*abb22n5+t1*t5*abb22n17+t1*t6*abb22n4+t1*t7*abb22n3+t1*t8*abb22n3+t1*t9&
      &*abb22n3+t10*t13*abb22n34+t10*t3*abb22n13+t10*t4*abb22n2+t10*t5*abb22n19+&
      &t11*t3*abb22n13+t11*t4*abb22n2+t13*t5*abb22n35+t2*t3*abb22n15+t2*t4*abb22&
      &n6+t2*t5*abb22n27+t3*t5*abb22n30+t4*t5*abb22n22+t5*t6*abb22n23+t1*t13*t2*&
      &abb22n42+t1*t13*t4*abb22n39+t1*t13*t5*abb22n37+t1*t13*t6*abb22n38+t1*t13*&
      &t7*abb22n36+t1*t13*t8*abb22n36+t1*t13*t9*abb22n36+t1*t13*abb22n44*(Q(1)*s&
      &pvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t1*t2*t3*a&
      &bb22n16+t1*t2*t5*abb22n29+t10*t13*t4*abb22n32+t13*t4*t5*abb22n31+t13*t5*a&
      &bb22n40*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6&
      &(4))+t13*t5*abb22n43*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-&
      &Q(4)*spvak5k2(4))+t2*t3*t5*abb22n41+t2*t4*t5*abb22n20+t2*t5*abb22n21*(Q(1&
      &)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t1*t13*&
      &t2*t4*abb22n45)
      numerator = cmplx(real(d22, ki), aimag(d22), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd22h5
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d22
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6-k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d22 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t3 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = t5*abb22n25
      t13 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d22 = (t1*abb22n10+t10*abb22n9+t11*abb22n9+t12*t7+t12*t8+t12*t9+t2*abb22n1&
      &1+t3*abb22n12+t4*abb22n18+t5*abb22n26+t5*t5*abb22n24+t6*abb22n7+t7*abb22n&
      &8+t8*abb22n8+t9*abb22n8+t1*t13*abb22n33+t1*t2*abb22n28+t1*t3*abb22n14+t1*&
      &t4*abb22n5+t1*t5*abb22n17+t1*t6*abb22n4+t1*t7*abb22n3+t1*t8*abb22n3+t1*t9&
      &*abb22n3+t10*t13*abb22n34+t10*t3*abb22n13+t10*t4*abb22n2+t10*t5*abb22n19+&
      &t11*t3*abb22n13+t11*t4*abb22n2+t13*t5*abb22n35+t2*t3*abb22n15+t2*t4*abb22&
      &n6+t2*t5*abb22n27+t3*t5*abb22n30+t4*t5*abb22n22+t5*t6*abb22n23+t1*t13*t2*&
      &abb22n42+t1*t13*t4*abb22n39+t1*t13*t5*abb22n37+t1*t13*t6*abb22n38+t1*t13*&
      &t7*abb22n36+t1*t13*t8*abb22n36+t1*t13*t9*abb22n36+t1*t13*abb22n44*(Q(1)*s&
      &pvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t1*t2*t3*a&
      &bb22n16+t1*t2*t5*abb22n29+t10*t13*t4*abb22n32+t13*t4*t5*abb22n31+t13*t5*a&
      &bb22n40*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6&
      &(4))+t13*t5*abb22n43*(Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-&
      &Q(4)*spvak5k2(4))+t2*t3*t5*abb22n41+t2*t4*t5*abb22n20+t2*t5*abb22n21*(Q(1&
      &)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t1*t13*&
      &t2*t4*abb22n45)

      numerator = cmplx(real(d22, ki), aimag(d22), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d22h5l1
