module     P4B_ddx_ddx_d52h5l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity5/d52h5l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram52_sign, shift => diagram52_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd52h5
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d52
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d52 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = t1*abb52n12
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = t1*abb52n13
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t16 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t17 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t18 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t19 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t20 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t21 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t22 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t23 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t24 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t25 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      d52 = (t1*abb52n39+t1*abb52n6+t10*t9+t11*t12+t12*t13+t2*abb52n40+t3*abb52n&
      &47+t4*abb52n7+t8*t9+t1*t20*abb52n45+t1*t3*abb52n60+t1*t6*abb52n15+t1*t7*a&
      &bb52n18+t1*abb52n20*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q&
      &(4)*spvak4k5(4))+t1*abb52n21*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spva&
      &k4k6(3)-Q(4)*spvak4k6(4))+t1*abb52n22*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-&
      &Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t1*abb52n23*(Q(1)*spvak4k8(1)-Q(2)*spv&
      &ak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t1*abb52n36*(Q(1)*spvak5k2(1)&
      &-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t1*abb52n37*(Q(1)*sp&
      &vak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t1*abb52n38&
      &*(Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t1&
      &*abb52n41*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8&
      &k2(4))+t10*t21*abb52n48+t10*t5*abb52n8+t11*t21*abb52n49+t11*t5*abb52n9+t1&
      &3*t21*abb52n49+t13*t5*abb52n9+t14*t16*abb52n25+t14*t17*abb52n27+t14*t18*a&
      &bb52n28+t14*t19*abb52n30+t14*t20*abb52n43+t14*t22*abb52n53+t14*t23*abb52n&
      &55+t14*t24*abb52n56+t14*t25*abb52n58+t14*t3*abb52n61+t14*t6*abb52n14+t14*&
      &t7*abb52n19+t15*t16*abb52n24+t15*t17*abb52n26+t15*t18*abb52n29+t15*t19*ab&
      &b52n31+t15*t20*abb52n42+t15*t22*abb52n52+t15*t23*abb52n54+t15*t24*abb52n5&
      &7+t15*t25*abb52n59+t15*t3*abb52n62+t15*t6*abb52n16+t15*t7*abb52n17+t16*t2&
      &0*abb52n32+t17*t20*abb52n33+t18*t20*abb52n34+t19*t20*abb52n35+t2*t20*abb5&
      &2n46+t20*t22*abb52n64+t20*t23*abb52n63+t20*t24*abb52n66+t20*t25*abb52n65+&
      &t20*t3*abb52n67+t20*t4*abb52n44+t21*t6*abb52n50+t21*t7*abb52n51+t21*t8*ab&
      &b52n48+t5*t6*abb52n10+t5*t7*abb52n11+t5*t8*abb52n8+t10*t20*t3*abb52n69+t1&
      &1*t20*t3*abb52n68+t13*t20*t3*abb52n68+t20*t3*t6*abb52n70+t20*t3*t7*abb52n&
      &71+t20*t3*t8*abb52n69)
      numerator = cmplx(real(d52, ki), aimag(d52), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd52h5
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d52
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d52 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      t6 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t9 = t1*abb52n12
      t10 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t11 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t12 = t1*abb52n13
      t13 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t16 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t17 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t18 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t19 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t20 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t21 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t22 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t23 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t24 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t25 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      d52 = (t1*abb52n39+t1*abb52n6+t10*t9+t11*t12+t12*t13+t2*abb52n40+t3*abb52n&
      &47+t4*abb52n7+t8*t9+t1*t20*abb52n45+t1*t3*abb52n60+t1*t6*abb52n15+t1*t7*a&
      &bb52n18+t1*abb52n20*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q&
      &(4)*spvak4k5(4))+t1*abb52n21*(Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spva&
      &k4k6(3)-Q(4)*spvak4k6(4))+t1*abb52n22*(Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-&
      &Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t1*abb52n23*(Q(1)*spvak4k8(1)-Q(2)*spv&
      &ak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t1*abb52n36*(Q(1)*spvak5k2(1)&
      &-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t1*abb52n37*(Q(1)*sp&
      &vak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+t1*abb52n38&
      &*(Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4))+t1&
      &*abb52n41*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k2(3)-Q(4)*spvak8&
      &k2(4))+t10*t21*abb52n48+t10*t5*abb52n8+t11*t21*abb52n49+t11*t5*abb52n9+t1&
      &3*t21*abb52n49+t13*t5*abb52n9+t14*t16*abb52n25+t14*t17*abb52n27+t14*t18*a&
      &bb52n28+t14*t19*abb52n30+t14*t20*abb52n43+t14*t22*abb52n53+t14*t23*abb52n&
      &55+t14*t24*abb52n56+t14*t25*abb52n58+t14*t3*abb52n61+t14*t6*abb52n14+t14*&
      &t7*abb52n19+t15*t16*abb52n24+t15*t17*abb52n26+t15*t18*abb52n29+t15*t19*ab&
      &b52n31+t15*t20*abb52n42+t15*t22*abb52n52+t15*t23*abb52n54+t15*t24*abb52n5&
      &7+t15*t25*abb52n59+t15*t3*abb52n62+t15*t6*abb52n16+t15*t7*abb52n17+t16*t2&
      &0*abb52n32+t17*t20*abb52n33+t18*t20*abb52n34+t19*t20*abb52n35+t2*t20*abb5&
      &2n46+t20*t22*abb52n64+t20*t23*abb52n63+t20*t24*abb52n66+t20*t25*abb52n65+&
      &t20*t3*abb52n67+t20*t4*abb52n44+t21*t6*abb52n50+t21*t7*abb52n51+t21*t8*ab&
      &b52n48+t5*t6*abb52n10+t5*t7*abb52n11+t5*t8*abb52n8+t10*t20*t3*abb52n69+t1&
      &1*t20*t3*abb52n68+t13*t20*t3*abb52n68+t20*t3*t6*abb52n70+t20*t3*t7*abb52n&
      &71+t20*t3*t8*abb52n69)

      numerator = cmplx(real(d52, ki), aimag(d52), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d52h5l1
