module     P4B_ddx_ddx_d58h5l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P4B_ddx_
   ! ddx/helicity5/d58h5l1.f90
   ! generator: haggies (1.1)
   use P4B_ddx_ddx_config, only: ki
   use P4B_ddx_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P4B_ddx_ddx_groups, only: &
!           & sign => diagram58_sign, shift => diagram58_shift
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd58h5
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d58
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d58 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = t1*abb58n15
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = t1*abb58n16
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t17 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t18 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t19 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t20 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t21 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t22 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t23 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t24 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t25 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d58 = (t1*abb58n13+t1*abb58n23+t1*abb58n64+t10*t11+t10*t9+t2*abb58n14+t2*a&
      &bb58n66+t3*abb58n37+t4*abb58n63+t6*t7+t7*t8+t1*t13*abb58n18+t1*t15*abb58n&
      &21+t1*t18*abb58n48+t1*t2*abb58n29+t1*t20*abb58n53+t1*t23*abb58n74+t1*t25*&
      &abb58n79+t1*t5*abb58n27+t1*abb58n42*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(&
      &3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t1*abb58n43*(Q(1)*spvak4k6(1)-Q(2)*spvak&
      &4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4))+t1*abb58n44*(Q(1)*spvak4k7(1)-Q&
      &(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t1*abb58n45*(Q(1)*spva&
      &k4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t1*abb58n60*(&
      &Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t1*a&
      &bb58n61*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2&
      &(4))+t1*abb58n62*(Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)&
      &*spvak7k2(4))+t1*abb58n65*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k&
      &2(3)-Q(4)*spvak8k2(4))+t11*t16*abb58n39+t11*t21*abb58n67+t12*t13*abb58n17&
      &+t12*t15*abb58n22+t12*t17*abb58n47+t12*t18*abb58n50+t12*t19*abb58n51+t12*&
      &t2*abb58n30+t12*t20*abb58n54+t12*t22*abb58n71+t12*t23*abb58n75+t12*t24*ab&
      &b58n77+t12*t25*abb58n78+t12*t5*abb58n25+t13*t14*abb58n19+t13*t16*abb58n40&
      &+t13*t21*abb58n69+t14*t15*abb58n20+t14*t17*abb58n46+t14*t18*abb58n49+t14*&
      &t19*abb58n52+t14*t2*abb58n31+t14*t20*abb58n55+t14*t22*abb58n72+t14*t23*ab&
      &b58n73+t14*t24*abb58n76+t14*t25*abb58n80+t14*t5*abb58n24+t15*t16*abb58n41&
      &+t15*t21*abb58n70+t16*t6*abb58n38+t16*t8*abb58n38+t16*t9*abb58n39+t17*t5*&
      &abb58n56+t18*t5*abb58n57+t19*t5*abb58n58+t2*t5*abb58n12+t2*t5*abb58n32+t2&
      &0*t5*abb58n59+t21*t6*abb58n68+t21*t8*abb58n68+t21*t9*abb58n67+t22*t5*abb5&
      &8n81+t23*t5*abb58n82+t24*t5*abb58n83+t25*t5*abb58n84+t3*t5*abb58n26+t4*t5&
      &*abb58n28+t11*t2*t5*abb58n33+t13*t2*t5*abb58n35+t15*t2*t5*abb58n36+t2*t5*&
      &t6*abb58n34+t2*t5*t8*abb58n34+t2*t5*t9*abb58n33)
      numerator = cmplx(real(d58, ki), aimag(d58), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P4B_ddx_ddx_globalsl1, only: epspow
      use P4B_ddx_ddx_kinematics
      use P4B_ddx_ddx_abbrevd58h5
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d58
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d58 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t3 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = t1*abb58n15
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = t1*abb58n16
      t11 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t12 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t17 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t18 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t19 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t20 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t21 = (Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4)&
      &)
      t22 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t23 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t24 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t25 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d58 = (t1*abb58n13+t1*abb58n23+t1*abb58n64+t10*t11+t10*t9+t2*abb58n14+t2*a&
      &bb58n66+t3*abb58n37+t4*abb58n63+t6*t7+t7*t8+t1*t13*abb58n18+t1*t15*abb58n&
      &21+t1*t18*abb58n48+t1*t2*abb58n29+t1*t20*abb58n53+t1*t23*abb58n74+t1*t25*&
      &abb58n79+t1*t5*abb58n27+t1*abb58n42*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(&
      &3)*spvak4k5(3)-Q(4)*spvak4k5(4))+t1*abb58n43*(Q(1)*spvak4k6(1)-Q(2)*spvak&
      &4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4))+t1*abb58n44*(Q(1)*spvak4k7(1)-Q&
      &(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4))+t1*abb58n45*(Q(1)*spva&
      &k4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t1*abb58n60*(&
      &Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t1*a&
      &bb58n61*(Q(1)*spvak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2&
      &(4))+t1*abb58n62*(Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)&
      &*spvak7k2(4))+t1*abb58n65*(Q(1)*spvak8k2(1)-Q(2)*spvak8k2(2)-Q(3)*spvak8k&
      &2(3)-Q(4)*spvak8k2(4))+t11*t16*abb58n39+t11*t21*abb58n67+t12*t13*abb58n17&
      &+t12*t15*abb58n22+t12*t17*abb58n47+t12*t18*abb58n50+t12*t19*abb58n51+t12*&
      &t2*abb58n30+t12*t20*abb58n54+t12*t22*abb58n71+t12*t23*abb58n75+t12*t24*ab&
      &b58n77+t12*t25*abb58n78+t12*t5*abb58n25+t13*t14*abb58n19+t13*t16*abb58n40&
      &+t13*t21*abb58n69+t14*t15*abb58n20+t14*t17*abb58n46+t14*t18*abb58n49+t14*&
      &t19*abb58n52+t14*t2*abb58n31+t14*t20*abb58n55+t14*t22*abb58n72+t14*t23*ab&
      &b58n73+t14*t24*abb58n76+t14*t25*abb58n80+t14*t5*abb58n24+t15*t16*abb58n41&
      &+t15*t21*abb58n70+t16*t6*abb58n38+t16*t8*abb58n38+t16*t9*abb58n39+t17*t5*&
      &abb58n56+t18*t5*abb58n57+t19*t5*abb58n58+t2*t5*abb58n12+t2*t5*abb58n32+t2&
      &0*t5*abb58n59+t21*t6*abb58n68+t21*t8*abb58n68+t21*t9*abb58n67+t22*t5*abb5&
      &8n81+t23*t5*abb58n82+t24*t5*abb58n83+t25*t5*abb58n84+t3*t5*abb58n26+t4*t5&
      &*abb58n28+t11*t2*t5*abb58n33+t13*t2*t5*abb58n35+t15*t2*t5*abb58n36+t2*t5*&
      &t6*abb58n34+t2*t5*t8*abb58n34+t2*t5*t9*abb58n33)

      numerator = cmplx(real(d58, ki), aimag(d58), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P4B_ddx_ddx_d58h5l1
